{$mode objfpc}
{$h+}
program tinotify;

uses sysutils,inotify, baseunix;

Procedure WatchDirectory(d : string);

Const
  Events = IN_MODIFY or IN_ATTRIB or IN_CREATE or IN_DELETE;

Var
  fd, wd,fnl,len : cint;
  fds : tfdset;
  e : ^inotify_event;
  buf : Array[0..1023*4] of Byte; // 4K Buffer
  fn : string;
  p : pchar;
  
begin
  fd:=inotify_init;
  try
    wd:=inotify_add_watch(fd,pchar(d),Events);
    fpFD_Zero(fds);
    fpFD_SET(fd,fds);
    While (fpSelect(fd+1,@fds,nil,nil,nil)>=0) do
      begin
      len:=fpRead(fd,buf,sizeof(buf)); 
      e:=@buf;
      While ((pchar(e)-@buf)<len) do 
        begin
        fnl:=e^.len;
        if (fnl>0) then
          begin
          p:=@e^.name+fnl-1;
          While (p^=#0) do
            begin
            dec(p);
            dec(fnl);
            end;
          end;  
        setlength(fn,fnl);
        if (fnl>0) then
          move(e^.name,fn[1],fnl);
        Writeln('Change ',e^.mask,' (',
                InotifyEventsToString(e^.mask),
                ') detected for file "',fn,'"');
        ptrint(e):=ptrint(e)+sizeof(inotify_event)+e^.len-1;
        end;
      end;
  finally
    fpClose(fd);
  end;    
end;

Var
  D : String;
  
begin
  if ParamCount=1 then
    d:=paramstr(1)
  else
    d:=ExtractFilePath(paramstr(0));  
  d:=ExcludeTrailingPathDelimiter(d);
  WatchDirectory(d); 
end.